#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "header.h"

static int cargarlista(struct nodo **h, char *archivo) {
	FILE *f;
	struct nodo *q;
	char buf[32];
	char *token;
	char separador[2] = ",";
	int cant = 0;
	
	f = fopen(archivo, "r");
	if(!f) return -1; // error
	
	while(!feof(f)) {
		fgets(buf, 32, f);
		if(!strcmp(buf, "\n")) continue; // vacia
		q = malloc(sizeof(struct nodo));
		if(!q) goto err;
		
		token = strtok(buf, separador);
		if(!token) goto err;
		q->e.frame = atoi(token);
		
		token = strtok(NULL, separador);
		if(!token) goto err;
		q->e.errx = (float) atoi(token);
		
		token = strtok(NULL, separador);
		if(!token) goto err;
		q->e.erry = (float) atoi(token);
		
		queue(h, q);
		cant++;
	}
	
	fclose(f);
	return cant;
err:
	free(q);
	fclose(f);
	return -2;
}

static struct nodo *buscarnodo(int frame, struct nodo **h) {
	struct nodo *q = *h;
	
	while(q) {
		if(q->e.frame == frame) return q;
		q = q->next;
	}
	return NULL;
}

static void compararvalores(struct nodo **p, struct nodo **h1, struct nodo **h2) {
	struct nodo *q, *r, *s;
	
	if(!(*h1) || !(*h2)) return;
	
	q = *h1;
	while(q) {
		r = buscarnodo(q->e.frame, h2);
		if(!r) pop(h1, q); // si no encontre esa frame en la otra lista, lo saco
		else {
			s = malloc(sizeof(struct nodo));
			if(!s) return; // fallo malloc
			s->e.frame = q->e.frame;
			s->e.errx = q->e.errx - r->e.errx;
			s->e.erry = q->e.erry - r->e.erry;
			queue(p, s);
		}
		q = q->next;
	}
}

static void liberarlista(struct nodo **h) {
	struct nodo *q;
	
	while(*h) {
		q = *h;
		*h = (*h)->next;
		free(q);
	}
}

static int conteolista(struct nodo **h) {
	int i;
	struct nodo *q;
	q = *h;
	for(i = 0; q != NULL; i++) q = q->next;
	return i;
}

int comparararchivos(struct nodo **p, char *archresultado, char *archpatron) {
	struct nodo *h1 = NULL, *h2 = NULL;
	
	if(cargarlista(&h1, archresultado) < 0)
		return -1;
	if(cargarlista(&h2, archpatron) < 0)
		return -2;
	
	compararvalores(p, &h1, &h2);
	
	liberarlista(&h1);
	liberarlista(&h2);
	
	return conteolista(p);
}
